<?php
$system_settings = $this->settings_model->getSettings("SYSTEM");
$invoice_settings = $this->settings_model->getSettings("INVOICE");
$isStriped = $invoice_settings->table_strip=="1"?"table_invoice-striped":"";
$isBordered = $invoice_settings->table_border=="1"?"table_invoice-bordered":"";
$headCol = ( isset($invoice->date_due) && $invoice->date_due != "" )?3:4;
$currency = $this->settings_model->getFormattedCurrencies($invoice->currency);
if (ITEM_TAX==2) {
	$item_taxes = array();
	$total_discounts = 0;
}
?>
<?php if ($system_settings->show_status): ?>
	<div class="invoice_status"><?php echo lang($invoice->status) ?></div>
<?php endif ?>
<div class='page_split'>
	<?php if (!empty($invoice->description)): ?>
		<center><i><small><?php echo $invoice->description  ?></small></i></center>
	<?php endif ?>
	<div class="row row-equal text-md-center">
		<div class="col-xs-<?php echo $headCol ?>">
			<h3 class="inv col"><b>BON DE LIVRAISON N: </b><?php echo $invoice->no; ?></h3>
		</div>
		<div class="col-xs-<?php echo $headCol ?>">
		</div>
		<div class="col-xs-<?php echo $headCol ?>">
			<h3 class="inv col"><b><?php echo lang("date"); ?>: </b><?php echo date(PHP_DATE, strtotime($invoice->date)); ?></h3>
		</div>
		<?php if ( isset($invoice->date_due) && $invoice->date_due != "" ): ?>
		<div class="col-xs-3">
			<h3 class="inv col"><b><?php echo lang("date_due"); ?>: </b><?php echo date(PHP_DATE, strtotime($invoice->date_due)); ?></h3>
		</div>
		<?php endif ?>
	</div>
	<hr>
	<?php
    $cf = $this->settings_model->SYS_Settings;
    $custom_fields = "";
	    if( isset($invoice->custom_field1) && $invoice->custom_field1 && trim($cf->invoice_cf1) != "" ){
	   		$custom_fields .= '<div class="col-xs-3"><h3 class="inv col m-a-0 no-margin"><b>'.$cf->invoice_cf1.": </b>".$invoice->custom_field1.'</h3></div>';
	   	}
	    if( isset($invoice->custom_field2) && $invoice->custom_field2 && trim($cf->invoice_cf2) != "" ){
	   		$custom_fields .= '<div class="col-xs-3"><h3 class="inv col m-a-0 no-margin"><b>'.$cf->invoice_cf2.": </b>".$invoice->custom_field2.'</h3></div>';
	   	}
	    if( isset($invoice->custom_field3) && $invoice->custom_field3 && trim($cf->invoice_cf3) != "" ){
	   		$custom_fields .= '<div class="col-xs-3"><h3 class="inv col m-a-0 no-margin"><b>'.$cf->invoice_cf3.": </b>".$invoice->custom_field3.'</h3></div>';
	   	}
	    if( isset($invoice->custom_field4) && $invoice->custom_field4 && trim($cf->invoice_cf4) != "" ){
	   		$custom_fields .= '<div class="col-xs-3"><h3 class="inv col m-a-0 no-margin"><b>'.$cf->invoice_cf4.": </b>".$invoice->custom_field4.'</h3></div>';
	   	}
	   	if( $custom_fields != "" ){
	    	echo '<div class="row text-md-center">'.$custom_fields."</div><hr>";
	   	}
	?>
	<?php echo $this->load->view('billers/biller_view', array("biller"=>$invoice_biller,"type"=>'bl'), true); ?>
	<br>
	<table class="table_invoice <?php echo $isBordered." ".$isStriped ?>" style="margin-bottom: 5px;" cellpadding="0" cellspacing="0" border="0">
		<thead>
			<tr>
				<th><?php echo lang("n°"); ?></th>
				<th><?php echo lang("description"); ?> (<?php echo lang("code"); ?>)</th>
				
			</tr>
		</thead>
		<tbody>
			<?php
				$r = 1;
				foreach ($invoice_items as $row) {
					if(is_object($row)){$row = objectToArray($row);}
			?>
			<tr>
				<td class="text-md-center"><?php echo $r; ?></td>
				<?php if ($system_settings->description_inline): ?>
					<td class="text-md-left"><?php echo $row["name"].(!empty($row["description"])?" (".$row["description"].")":""); ?></td>
				<?php else: ?>
					<td class="text-md-left">
						<?php echo $row["name"]; ?><br>
						<?php if (!empty($row["description"])): ?>
							<small class="text-muted font-italic"><?php echo str_replace("\n", "<br>", $row["description"]); ?></small>
						<?php endif ?>
					</td>
				<?php endif ?>
			
			</tr>
				<?php } ?>
		
		</tbody>
	</table>


<?php
if( !$system_settings->note_terms_on_page ){
	$class = "col-xs-12 inv";
	if ( !empty($invoice->note) && !empty($invoice->terms) ){
		$class = "col-xs-6 inv";
	}
	if ( !empty($invoice->note) ){
		echo "<div class='".$class."'><strong>".lang("note")."</strong><p>".$invoice->note."</p></div>";
	}
	if ( !empty($invoice->terms) ){
		echo "<div class='".$class."'><strong>".lang("condition_terms")."</strong><p>".$invoice->terms."</p></div>";
	}
}
?>
</div>
